unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Image1: TImage;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    Label2: TLabel;
    Image2: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label9: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    FBitmap: TBitmap;
    FSource: TBitmap;
    FTemplate: TBitmap;
    FRects: array[0..107] of TRect;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  `tB^sNX
type
    TTest = class
    protected
        FWork: TBitmap;
        FImage: TBitmap;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure LinearSmoothingGrayScaleImage(Source: TBitmap);
    public
        property Image: TBitmap read FImage;
    end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TTest.Create();
var
    i: Integer;
    LogPalette: TMaxLogPalette;
begin
    FWork  := TBitmap.Create();
    FImage := TBitmap.Create();

    with LogPalette do
    begin
        palNumEntries := 256;
        palVersion := $0300;
        for i := 0 to 255 do
        begin
            palPalEntry[i].peRed   := 255 - i;
            palPalEntry[i].peGreen := 255 - i;
            palPalEntry[i].peBlue  := 255 - i;
        end;
    end;
    FImage.Palette := CreatePalette(PLogPalette(@LogPalette)^);
    FImage.PixelFormat := pf8bit;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TTest.Destroy();
begin
    DeleteObject(FWork.Palette);
    DeleteObject(FImage.Palette);
    FWork.Free();
    FImage.Free();
end;

//-----------------------------------------------------------------------------
//  256FO[XP[摜`tB^
procedure TTest.LinearSmoothingGrayScaleImage(Source: TBitmap);
const
    WEIGHT: array[0..2] of array[0..2] of Byte
            = ((1, 1, 1), (1, 2, 1), (1, 1, 1));
    DIVVAL = 10;
var
    x, y: Integer;
    pSource: array[0..2] of PByteArray;
    pDest: PByteArray;
begin
    //  Ĥ߂ɃC[W]L
    FWork.Assign(Source);
    FWork.PixelFormat := pf8bit;

    //  ŏIC[Wݒ
    FImage.Assign(FWork);

    //  摜̒[1sNZ͕u(肪Ώ)

    //  tB^[
    for y := 1 to FWork.Height - 2 do
    begin
        pSource[0] := FWork.ScanLine[y - 1];
        pSource[1] := FWork.ScanLine[y];
        pSource[2] := FWork.ScanLine[y + 1];
        pDest := FImage.ScanLine[y];

        for x := 1 to FWork.Width - 2 do
        begin
            pDest[x] := Trunc((  WEIGHT[0][0] * pSource[0][x - 1]
                               + WEIGHT[0][1] * pSource[0][x]
                               + WEIGHT[0][2] * pSource[0][x + 1]
                               + WEIGHT[1][0] * pSource[1][x - 1]
                               + WEIGHT[1][1] * pSource[1][x]
                               + WEIGHT[1][2] * pSource[1][x + 1]
                               + WEIGHT[2][0] * pSource[2][x - 1]
                               + WEIGHT[2][1] * pSource[2][x]
                               + WEIGHT[2][2] * pSource[2][x + 1]) / DIVVAL);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormCreate(Sender: TObject);
var
    x, y, Index: Integer;
var
    i: Integer;
    LogPalette: TMaxLogPalette;
begin
    //  _uobt@prbg}bv
    FBitmap := TBitmap.Create();
    FBitmap.PixelFormat := pf8bit;

    //  O[XP[ɂ邽߂(?)pbg쐬
    with LogPalette do
    begin
        palNumEntries := 256;
        palVersion := $0300;
        for i := 0 to 255 do
        begin
            palPalEntry[i].peRed   := 255 - i;
            palPalEntry[i].peGreen := 255 - i;
            palPalEntry[i].peBlue  := 255 - i;
        end;
    end;
    FBitmap.Palette := CreatePalette(PLogPalette(@LogPalette)^);

    //  ev[g摜prbg}bv
    FTemplate := TBitmap.Create();
    FTemplate.PixelFormat := pf8bit;
    FTemplate.Width := Image2.Width;
    FTemplate.Height := Image2.Height;
    FTemplate.Palette := CreatePalette(PLogPalette(@LogPalette)^);
    FTemplate.Canvas.FillRect(Bounds(0, 0, FTemplate.Width, FTemplate.Height));

    FSource := TBitmap.Create();
    FSource.Width := PaintBox1.Width;
    FSource.Height := PaintBox1.Height;
    FSource.Canvas.Font.Assign(PaintBox1.Font);
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];

    //  360pixel x 480pixel ̉摜A40x40̉摜108ɕ
    Index := 0;
    y := 0;
    while (y < 480) do
    begin
        x := 0;
        while (x < 360) do
        begin
            FRects[Index] := Bounds(x, y, 40, 40);
            Inc(Index);
            Inc(x, 40);
        end;
        Inc(y, 40);
    end;
    FBitmap.Width := 40;
    FBitmap.Height := 40;

    //  摜`悷郊Xg{bNX̃ACeݒ
    ListBox1.Count := Length(FRects);
    ListBox1.ItemIndex := 0;
    ListBox1Click(ListBox1);
end;

//-----------------------------------------------------------------------------
//  fXgN^
procedure TForm1.FormDestroy(Sender: TObject);
begin
    DeleteObject(FBitmap.Palette);
    DeleteObject(FTemplate.Palette);
    FBitmap.Free();
    FTemplate.Free();
    FSource.Free();
end;

//-----------------------------------------------------------------------------
//  摜`
procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    i: Integer;
    r: TRect;
    OldBkMode: Integer;
begin
    //  wihԂ
    FSource.Canvas.Draw(0, 0, Image1.Picture.Bitmap);

    //  Ԃŕ`
    FSource.Canvas.Pen.Color := clRed;
    FSource.Canvas.Font.Color := clRed;
    OldBkMode := SetBkMode(FSource.Canvas.Handle, TRANSPARENT);

    for i := Low(FRects) to High(Low(FRects)) do
    begin
        r := FRects[i];
        FSource.Canvas.Polyline([r.TopLeft, Point(r.Left, r.Bottom), r.BottomRight, Point(r.Right, r.Top), r.TopLeft]);
        DrawText(FSource.Canvas.Handle,
                PChar(IntToStr(i)),
                -1,
                r,
                DT_SINGLELINE or DT_CENTER or DT_VCENTER);
    end;

    SetBkMode(FSource.Canvas.Handle, OldBkMode);
    FSource.Canvas.Font.Color := clBlack;
    FSource.Canvas.Pen.Color := clBlack;

    //  _uobt@ʂɓ]
    BitBlt(PaintBox1.Canvas.Handle, 0, 0, PaintBox1.Width, PaintBox1.Height,
            FSource.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
//  摜`
procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State:   TOwnerDrawState);
var
    r: TRect;
    h, w, x, y: Integer;
    Sum: Integer;
    Sumd: Double;
    Item: String;
var
    i: Integer;
    Test: TTest;
begin
    ListBox1.Canvas.FillRect(Rect);

    //  ̈o
    r := FRects[Index];

    //  摜]L
    BitBlt(FBitmap.Canvas.Handle, 0, 0, FBitmap.Width, FBitmap.Height,
            Image1.Picture.Bitmap.Canvas.Handle, r.Left, r.Top, SRCCOPY);

    //  
    if (CheckBox1.Checked) then
    begin
        Test := TTest.Create();
        for i := 1 to UpDown1.Position do
        begin
            Test.LinearSmoothingGrayScaleImage(FBitmap);
            FBitmap.Assign(Test.Image);
        end;
        Test.Free();
    end;

    //  _uobt@ʂɓ]
    BitBlt(ListBox1.Canvas.Handle, Rect.Left + 35, Rect.Top + 2, FBitmap.Width, FBitmap.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);
    //  CfbNXo
    r := Rect;
    r.Left := r.Left + 5;
    r.Right := r.Left + 18;
    DrawText(ListBox1.Canvas.Handle,
            PChar(IntToStr(Index)),
            -1,
            r,
            DT_SINGLELINE or DT_RIGHT or DT_VCENTER);

    //  uĂxvvZ
    h := FBitmap.Height;
    w := FBitmap.Width;
    r := FRects[Index];

    Sum := 0;
    for y := 0 to h - 1 do
    begin
        for x := 0 to w - 1 do
        begin
            //  ̉摜ƃev[g摜̊Kl̍𑫂ł
            Inc(Sum, Abs(PByteArray(FBitmap.ScanLine[y])[x] - PByteArray(FTemplate.ScanLine[y])[x]));
        end;
    end;

    //  uĂxv 0..1 ɕϊ(1 ɋ߂قǎĂ)
    Sumd := 1 - Sum / (255 * h * w);

    //  uĂxvo
    Item := FormatFloat('0.00', Sumd);
    if (Sumd >= 0.90) then
    begin
        Item := Item + '#';
    end
    else
    begin
        Item := Item + ' ';
    end;

    r := Rect;
    r.Left := r.Left + 60;
    DrawText(ListBox1.Canvas.Handle,
            PChar(Item),
            -1,
            r,
            DT_SINGLELINE or DT_CENTER or DT_VCENTER);
end;

//-----------------------------------------------------------------------------
//  rɂ摜I
procedure TForm1.ListBox1Click(Sender: TObject);
var
    r: TRect;
    i: Integer;
    Test: TTest;
begin
    if (ListBox1.ItemIndex <> -1) then
    begin
        r := FRects[ListBox1.ItemIndex];

        BitBlt(FTemplate.Canvas.Handle, 0, 0, FTemplate.Width, FTemplate.Height,
               Image1.Picture.Bitmap.Canvas.Handle, r.Left, r.Top, SRCCOPY);

        //  
        if (CheckBox2.Checked) then
        begin
            Test := TTest.Create();
            for i := 1 to UpDown1.Position do
            begin
                Test.LinearSmoothingGrayScaleImage(FTemplate);
                FTemplate.Assign(Test.Image);
            end;
            Test.Free();
        end;

        Image2.Picture.Bitmap.Assign(FTemplate);

        ListBox1.Repaint();
    end;
end;

//-----------------------------------------------------------------------------
//  ̉񐔕ύX
procedure TForm1.Edit1Change(Sender: TObject);
begin
    //  ev[g摜ݒ肵Ȃ
    ListBox1Click(ListBox1);
end;

//-----------------------------------------------------------------------------
//  ̓Kp͈͕ύX
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    //  ev[g摜ݒ肵Ȃ
    ListBox1Click(ListBox1);
end;

end.
